//
//  NekoTyper.h
//  Neko Type-R

/*
Copyright (c) 2005 Vince Tagle <vtagle@newsguy.com>

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of 
the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO 
THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
SOFTWARE.
*/

#import <Cocoa/Cocoa.h>
#include "NekoConstants.h"


@class WordDispenser; 

@interface NekoTyper : NSObject 
{
	NSString*	name; 
	NSPoint		position; 
	SInt32		imageToDisplay; 
	SInt32		currentAction; 
	NSString*	wordToType; 
	float		moveTo; 
	BOOL		finishedRace; 
	UInt32		updateNextImageAtTime; 
	UInt32		fallAsleepAtTime; 
	BOOL		movingIntoStartingPosition; 
	SInt32		currentPowerup; 
	BOOL		shieldedFromBadPowerup; 
	
	NSMutableAttributedString*	wordToDisplay; 
	WordDispenser*				words;
	NSDictionary*				defaultTextAttributes; 
}

- (NSPoint)position; 
- (void)setPosition: (NSPoint)p; 

- (SInt32)imageToDisplay; 

- (BOOL)finishedRace;
- (void)setFinishedRace; 

- (SInt32)currentPowerup; 
- (BOOL)shieldedFromBadPowerup; 

- (BOOL)isMovingIntoStartingPosition; 
- (void)moveNekoForward: (SInt32)move;
- (BOOL)isMoving; 
- (void)update; 
- (void)reset; 
- (void)setNextWordToType; 
- (void)updateWordToDisplay: (SInt32)charactersMatched; 
- (void)powerupEffect: (SInt32)type withSound: (BOOL)sound; 

@end
